# 5.2 Linked Data

Linked Data dient der Verknüpfung zwischen Datensilos: Der Computer kann Verweisen in den Daten folgen und Zusatzinformationen aus externen Quellen automatisch heranziehen. Ein möglicher Anwendungsfall ist die Anzeige von Zusatzinformationen im Bibliothekskatalog über Personen, die nicht in den Katalogdaten stehen und beim Aufruf live aus einer Personendatenbank geladen werden.

Beispiel: [Suche nach "Picasso" im Katalog von Arthistoricum.net](http://katalog.arthistoricum.net/?tx_find_find[q][default]=Picasso)

Von technischer Seite ist das Format RDF sowie die Abfragesprache SPARQL von zentraler Bedeutung:

* Beispiel für SPARQL-Abfragen: https://query.wikidata.org
* [Einführungsartikel zu Resource Description Framework (RDF)](http://linkeddata.fh-htwchur.ch/Grundlagen-StrukturierteBeschreibung.html)
* [Einführungsartikel zur Abfragesprache SPARQL](http://linkeddata.fh-htwchur.ch/Grundlagen-SPARQL.html)

## Allgemeine Literatur

* Danowski, Patrick; Pohl, Adrian (Hrsg.) (2013): (Open) Linked Data in Bibliotheken. http://dx.doi.org/10.1515/9783110278736.
* Stettler, Niklaus; Aschwanden, Michael; Mastrandrea, Elena; Süsstrunk, Norman; Wenk, Bruno (2015): Linked (Open) Data - Von der Theorie zur Praxis. http://linkeddata.fh-htwchur.ch.

## Literatur zur Transformation von Bibliotheksmetadaten

* Beispiel für Mapping von MARC21 zu RDF: https://wiki.dnb.de/display/DINIAGKIM/MARC+21-RDF-Mapping
* Christina Harlow (2015): Data Munging Tools in Preparation for RDF: Catmandu and LODRefine. http://journal.code4lib.org/articles/11013.

## Aktuelle Entwicklungen

* vgl. Präsentation von Richard Wallis aus 2016: https://www.ucl.ac.uk/publishing/events/Richard_Wallis.pdf