# 5.3 Initiativen zum Austausch von Metadaten

## Kernpunkte

Aus dem Referat von Kristin Ameis und Kirstin Grantz am 24.10.2016 (vgl. [Präsentationsfolien](https://felixlohmeier.gitbooks.io/seminar-wir-bauen-uns-einen-bibliothekskatalog/content/slides/05_3_initiativen_zum_austausch_von_metadaten.pptx))

### Prinzipien und Handbuch

Die "Open Bibliographic Data Working Group" der Open Knowledge Foundation hat 2011 Prinzipien zu offenen bibliografischen Daten veröffentlicht (vgl. [Webseite im Internet Archive](http://web.archive.org/web/20160426071002/http://openbiblio.net/principles/)):

* Grundlage: [Open Definition](http://opendefinition.org) "Wissen ist offen, wenn jedeR darauf frei zugreifen, es nutzen, verändern und teilen kann"
* Empfohlene Lizenzen: Public Domain Dedication and License (PDDL) oder Creative Commons Zero (CC0)

Gemeinsam mit der Public Domain Working Group ist ein "Open Metadata Handbook" entstanden. Letzte stabile Version vom 12.3.2014: https://en.wikibooks.org/w/index.php?title=Open_Metadata_Handbook&stable=1

### Metadateninteroperabilität

* ein übergreifendes Metadatenformat ist nicht möglich wegen verschiedener zu beschreibender Ressourcen und verschiedener Anforderungen an die Daten (und unterschiedlichen Katalogisierungstraditionen)
* Interoperabilität zwischen Formaten muss durch Werkzeuge erreicht werden
* setzt offene Standards voraus

### Beispiel Open Library

* Ziel: "One web page for every book"
* Teilprojekt des Internet Archives
* Daten sind gemeinfrei, stammen von Verlagen, Bibliotheken und Privatpersonen
* strukturiertes Wiki im Hintergrund
* gestartet von [Aaron Swartz](http://www.aaronsw.com/weblog/openlibrary) (sehenswerte Filmdokumentation über Aaron Swartz: [The Internet's Own Boy](https://en.wikipedia.org/wiki/The_Internet's_Own_Boy))

### Bespiel Deutsche Nationalbibliothek

* seit 1.7.2015 Titeldaten DNB + Normdaten GND unter CC-0
* einmalige kostenfreie Anmeldung und Autorisierung
* Bezug über Online-Schnittstellen (SRU, OAI)
* Formate: MARC21, MARC21-xml, RDF

### Chancen durch offene Daten

* steigende Bedeutung von Bibliotheken durch mehr Sichtbarkeit im Web
* Nachnutzung der Daten z.B. von Verlagen, Archiven, Wikipedia
* Chance für Kooperationen, Forschung mit den Daten
* Kataloganreicherung (z. B. Schlagwörter): verbesserte Recherchequalität

### Gründe für geringe Beteiligung von Bibliotheken

* keine Notwendigkeit?
* Gefühl, die akribisch gesammelten Daten zu verschenken
* Angst, überflüssig zu werden
* nicht zuständig fühlen: Aufgabe der Verbünde

## Diskussion

Die Open Bibliographic Data Working Group der Open Knowledge Foundation ist leider nicht mehr aktiv. Generell sind Initiativen zum Austausch von Metadaten zwischen Bibliotheken eher rückläufig, stattdessen wird seit etwa 2013 auf politischer Ebene eine zentralistische Lösung gesucht. Aktuell arbeiten beispielsweise die Bibliotheksverbünde GBV und SWB an einer vertieften Kooperation (vgl. https://www.bsz-bw.de/news.html?id=445).

Die Software für Bibserver und Bibsoup wird ebenfalls leider nicht mehr weiterentwickelt. Die Domains sind teilweise offline, der Quellcode steht aber noch zur Verfügung.

Eine vielversprechende aktuelle Entwicklung ist das Projekt "WikiCite" der Wikimedia, das zum Ziel wissenschaftliche Ressourcen in Wikidata nachzuweisen und damit u.a. für Referenzen in der Wikipedia nutzbar zu machen. 2016 gab es dazu eine große Veranstaltung in Berlin: https://meta.wikimedia.org/wiki/WikiCite_2016